//+------------------------------------------------------------------+
#property copyright "Daniel Jose"
//+------------------------------------------------------------------+
void OnStart(void)
{
    long value = 0xFEDAF3F4F5F6F7F8;

    PrintFormat("Translation via standard library.\n" +
                "Decimal: %I64u\n" +
                "Octal  : %I64o\n" +
                "Hex    : %I64X",
                value, value, value
               );
    PrintFormat("Translation personal.\n" +
                "Decimal: %s\n" + 
                "Octal  : %s\n" +
                "Hex    : %s\n" +
                "Binary : %s",
                ValueToString(value, 0),
                ValueToString(value, 1),
                ValueToString(value, 2),
                ValueToString(value, 3)
               );
}
//+------------------------------------------------------------------+
string ValueToString(ulong arg, char format)
{
    const string szChars = "0123456789ABCDEF";
    string  sz0 = "";

    while (arg)
        switch (format)
        {
            case 0:
                sz0 = StringFormat("%c%s", szChars[(uchar)(arg % 10)], sz0);
                arg /= 10;
                break;
            case 1:
                sz0 = StringFormat("%c%s", szChars[(uchar)(arg & 0x7)], sz0);
                arg >>= 3;
                break;
            case 2:
                sz0 = StringFormat("%c%s", szChars[(uchar)(arg & 0xF)], sz0);
                arg >>= 4;
                break;
            case 3:
                sz0 = StringFormat("%c%s", szChars[(uchar)(arg & 0x1)], sz0);
                arg >>= 1;
                break;
            default:
                return "Format not implemented.";
        }

    return sz0;
}
//+------------------------------------------------------------------+